/// <reference types="node" />
import { Registry } from "../core/Registry";
import { IChassisPlugin, IChassisMiddleware, IChassisMetrics, IPackage } from ".";
import { IChassisLogger } from "./IChassisLogger";
import { IChassisSecrets } from "./IChassisSecrets";
import { EventEmitter } from "events";
import { Router, Application } from "express";
export interface IChassisContext extends IChassisLogger {
    audit(msg: any): void;
    resolve(item: any): void;
    pkg: IPackage;
    plugins: Registry<IChassisPlugin>;
    middleware: Registry<IChassisMiddleware>;
    metrics: IChassisMetrics;
    secrets: IChassisSecrets;
    uuid: string;
    bus: EventEmitter;
    app: Application;
    api: Router;
    config: any;
}
