"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const _ = require("lodash");
const helpers_1 = require("../helpers");
/**
 * Emit a local Event
 * ------------------
 *
 */
class Emit {
    constructor() {
        this.name = "api.emit";
        this.title = "Emit a local event";
    }
    /**
     * feature to send an event on local event bus
     *
     * @param context
     * @param options
     * @returns {TargetEndpoint}
     */
    fn(op, _options) {
        let options = _.extend({}, _options);
        assert(options.event, "missing emit.event");
        return (req, _res, next) => {
            let body = _.isObject(req.body) ? req.body : options.body;
            let meta = helpers_1.APIs.getOperationContext(op, req, options.meta);
            op.context.bus.emit(options.event, {
                data: body,
                meta: meta
            });
            op.context.log({ code: "emit:event", message: options.event, meta: meta, body: body });
            next();
        };
    }
    ;
}
exports.default = Emit;
//# sourceMappingURL=emit.js.map