import { IChassisContext, IChassisPlugin } from "../index";
import { KeycloakCerts } from "../helpers/KeycloakCerts";
/**
 * plugin has injects middleware 'after' every response is generated
 *
 * @param context
 * @param options
 * @returns {exports}
 */
export default class JWTPlugin implements IChassisPlugin {
    ALLOWED_ALGOS: string[];
    name: string;
    title: string;
    context: IChassisContext;
    secretOrCertificate: string;
    ignoreVerify: boolean;
    algo: string;
    debug: boolean;
    keycloakCerts: KeycloakCerts;
    hasCertificate(): boolean;
    getCertificate(): string;
    install(_context: IChassisContext, _options: any): void;
    _loadPublicKey(certificateFile: string): string;
    _downloadKeycloakCerts(url: string): void;
    _downloadPublicKey(url: string): void;
}
